package com.yifeng.rn.vpager;

/**
 * 作者: yangliu
 * 时间：17/3/7:下午7:13
 * 说明：
 */
import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.uimanager.events.Event;
import com.facebook.react.uimanager.events.RCTEventEmitter;

/**
 * Event emitted by {@link ReactViewPager} when selected page changes.
 *
 * Additional data provided by this event:
 *  - position - index of page that has been selected
 */
/* package */ class PageSelectedEvent extends Event<PageSelectedEvent> {

    public static final String EVENT_NAME = "topPageSelected";

    private final int mPosition;

    protected PageSelectedEvent(int viewTag, int position) {
        super(viewTag);
        mPosition = position;
    }

    @Override
    public String getEventName() {
        return EVENT_NAME;
    }

    @Override
    public void dispatch(RCTEventEmitter rctEventEmitter) {
        rctEventEmitter.receiveEvent(getViewTag(), getEventName(), serializeEventData());
    }

    private WritableMap serializeEventData() {
        WritableMap eventData = Arguments.createMap();
        eventData.putInt("position", mPosition);
        return eventData;
    }
}